unit CodigoBarras;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, funcoes;

function digEAN(Cod: real): string;
function CodBarras(cCodigo: string): string;
procedure ImprimirCodBar(Codigo: string; EspacoEsquerda: Integer; Espessura: Integer; Porta: string);

implementation

//Cria Digito EAN

function digEAN(Cod: real): string;
var
  dig, m, x, somatot: integer;
  nro: string;
begin
  nro := formatfloat('000000000000', cod);
  nro := Copy(Trim(nro), 1, 12);
  m := 1;
  somatot := 0;
  for x := 1 to 12 do
  begin
    somatot := somatot + (strtoint(copy(nro, x, 1)) * m);
    if m = 1 then
      m := 3
    else
      m := 1;
  end;
  if ((somatot div 10) * 10) = somatot then
    dig := 0
  else
    dig := (((somatot div 10) + 1) * 10) - somatot;

  result := nro + strzero(dig, 1);
end;

//**** gera string do cod. de barras ...  s imprimir

function CodBarras(cCodigo: string): string;
const
  cGuarda = '101';
  cCentro = '01010';
  UNIDIR_ON = CHR(27) + CHR(85) + CHR(1);
  DBL_STRIKE_ON = CHR(27) + CHR(71);
  LINE_SPACING = CHR(27) + CHR(51);
  DOUBLE_DENS = CHR(27) + CHR(76);
var
  acTableA, acTableB, acTableC, acTableLast: array[1..10] of string;
  cTableUse,
    cCodeBar,
    cTB: string;
  nLength, nCount, nPos: Integer;
begin
  acTableA[01] := '0001101';
  acTableA[02] := '0011001';
  acTableA[03] := '0010011';
  acTableA[04] := '0111101';
  acTableA[05] := '0100011';
  acTableA[06] := '0110001';
  acTableA[07] := '0101111';
  acTableA[08] := '0111011';
  acTableA[09] := '0110111';
  acTableA[10] := '0001011';

  acTableB[01] := '0100111';
  acTableB[02] := '0110011';
  acTableB[03] := '0011011';
  acTableB[04] := '0100001';
  acTableB[05] := '0011101';
  acTableB[06] := '0111001';
  acTableB[07] := '0000101';
  acTableB[08] := '0010001';
  acTableB[09] := '0001001';
  acTableB[10] := '0010111';

  acTableC[01] := '1110010';
  acTableC[02] := '1100110';
  acTableC[03] := '1101100';
  acTableC[04] := '1000010';
  acTableC[05] := '1011100';
  acTableC[06] := '1001110';
  acTableC[07] := '1010000';
  acTableC[08] := '1000100';
  acTableC[09] := '1001000';
  acTableC[10] := '1110100';

  acTableLast[01] := 'AAAAAA';
  acTableLast[02] := 'AABABB';
  acTableLast[03] := 'AABBAB';
  acTableLast[04] := 'AABBBA';
  acTableLast[05] := 'ABAABB';
  acTableLast[06] := 'ABBAAB';
  acTableLast[07] := 'ABBBAA';
  acTableLast[08] := 'ABABAB';
  acTableLast[09] := 'ABABBA';
  acTableLast[10] := 'ABBABA';

  //Primeiro Digito indica qual a sequencia de Tabelas a ser usada
  //cTableUse := acTableLast[STRTOINT(ESPLEFT(cCodigo,1))+1];
  cTableUse := acTableLast[STRTOINT(copy(cCodigo, 1, 1)) + 1];

  //Codificar primeira parte do Codigo
  cCodeBar := cGuarda;
  for nCount := 1 to 6 do
  begin
    cTB := COPY(cTableUse, nCount, 1);
    nPos := StrToInt(Copy(cCodigo, nCount + 1, 1)) + 1;
    if cTB = 'A' then
      cCodeBar := cCodeBar + acTableA[nPos]
    else
      cCodeBar := cCodeBar + acTableB[nPos];
  end;

  //Codificar a segunda parte do Codigo
  cCodebar := cCodeBar + cCentro;
  for nCount := 7 to 12 do
  begin
    nPos := StrToInt(Copy(cCodigo, nCount + 1, 1)) + 1;
    cCodeBar := cCodeBar + acTableC[nPos];
  end;

  //Introduzir Caracter de Guarda Final
  cCodeBar := cCodeBar + cGuarda;

  //Codigo de Barras Pronto! - Transformar p/ Padrao de Bits da Impressora
  //e duplicar as Barras p/ melhor definicao
  cCodeBar := StringReplace(cCodeBar, '1', chr(255) + chr(255), [rfReplaceAll]);
  cCodeBar := StringReplace(cCodeBar, '0', chr(0) + chr(0), [rfReplaceAll]);

  //Introduzir Caracteres de Comando da impressora
  nLength := LENGTH(cCodeBar);
  cCodeBar := DOUBLE_DENS + CHR(nLength mod 216) + CHR(StrToInt(FormatFloat('000', INT(nLength / 216)))) + cCodeBar;
  Result := cCodeBar;
end;

procedure ImprimirCodBar(Codigo: string; EspacoEsquerda: Integer; Espessura: Integer; Porta: string);
var
  Imp: TextFile;
  Linha: string;
  x: Integer;
const
  UNIDIR_ON = CHR(27) + CHR(85) + CHR(1);
  DBL_STRIKE_ON = CHR(27) + CHR(71);
  LINE_SPACING = CHR(27) + CHR(51);
begin

  AssignFile(imp, Porta);
  Rewrite(Imp);
  Writeln(Imp, UNIDIR_ON + DBL_STRIKE_ON + LINE_SPACING + CHR(24));

  Linha := CodBarras(Codigo);

  for x := 1 to Espessura do
  begin
    Writeln(Imp, Space(EspacoEsquerda) + Linha);
  end;

  CloseFile(imp);

end;

end.
