unit UFrmCadastroCliente;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Grids, DBGrids, ExtCtrls, StdCtrls, Buttons, SqlExpr, DB,
  Mask, DBCtrls, FMTBcd, QDialogs, Provider, DBClient,
  ZAbstractRODataset, ZAbstractDataset, ZDataset;

Const
  // Contantes reponsaveis pelo nome da tabela e o nome do campo principal (geralmente um campo que nao se repete "unico")
  TabelaReferencial = 'clientes';
  CampoReferencial = 'codigo';

type
  TFrmCadastroCliente = class(TForm)
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    DBGrid: TDBGrid;
    Panel2: TPanel;
    pesquisar: TBitBtn;
    ChavePesquisa: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    incluir: TBitBtn;
    alterar: TBitBtn;
    excluir: TBitBtn;
    salvar: TBitBtn;
    abandonar: TBitBtn;
    codigo: TDBEdit;
    CampoPesquisa: TComboBox;
    DataSource: TDataSource;
    SqlManipula: TZQuery;
    nome: TDBEdit;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormShow(Sender: TObject);
    procedure DBGridTitleClick(Column: TColumn);
    procedure pesquisarClick(Sender: TObject);
    procedure DBGridDblClick(Sender: TObject);
    procedure incluirClick(Sender: TObject);
    procedure alterarClick(Sender: TObject);
    procedure excluirClick(Sender: TObject);
    procedure salvarClick(Sender: TObject);
    procedure abandonarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HabilitaBotoes(aOpcao:integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);  // Linka os envento corsaida nos objetos
    function ValidaDados(aValor: String):boolean;
    function RetornaTipoCampo(NomeCampo : String): String;
    procedure Ordenar_Select(OS_Campo: String);
    procedure PageControlChanging(Sender: TObject; var AllowChange: Boolean);
    procedure ColocaMascaraCampos();
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    nFlagAlterar: boolean;
  public
    { Public declarations }
  end;

var
  FrmCadastroCliente: TFrmCadastroCliente;

implementation

uses funcoes, uBancoDados;
{$R *.dfm}

procedure TFrmCadastroCliente.FormShow(Sender: TObject);
var
  i : integer;
begin

  //define a pagina corrente ( Pesquisa )
  pagecontrol.TabIndex := 0;

  /// inicia o flag com false, pois nao est em mode alteracao
  nFlagAlterar := false ;

  //abre a tabela
  SQLManipula.Close;
  SQLManipula.SQL.Clear;
  SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + CampoReferencial + ' IS NULL');
  SQLManipula.Open;

  // linka o ClientDataSet no datasource
  DataSource.DataSet := SQLManipula;
  DataSource.Enabled := true;

  // Linka o datasource no grid de pesquisa
  dbgrid.DataSource := DataSource;
  //Cria Colunas em run Time
  dbgrid.Columns.State := csCustomized;

  for i := 0 to SQLManipula.FieldDefs.Count - 1 do begin
    //joga nome dos campos da tabela no ComboBox e trata o nome dos campos
    CampoPesquisa.Items.Add(PrimeiraLetraMaiscula(TiraUnderline(SQLManipula.FieldDefs.Items[i].Name)));
    //Para emiminar a coluna que j existe no grid
    if i <> 0 then begin
      DBGrid.Columns.Add;
    end;
    //adiciona nome dos campos da tabela no Grid e trata o nome das colunas
    DBGrid.Columns[i].FieldName := SQLManipula.FieldDefs.Items[i].Name;
    DBGrid.Columns[i].Title.Caption := PrimeiraLetraMaiscula(TiraUnderline(SQLManipula.FieldDefs.Items[i].Name));
    DBGrid.Columns[i].Title.Font.Style := [ fsBold ];
  end;

  // linka todos os campos Dbedit ao Datasource
  for i := 0 to ComponentCount -1 do begin
    if Components[i] is TDBEdit then begin
      TDBEdit(Components[i]).DataSource := DataSource;
    end;
  end;

  //// Lista todos os campos com o determinado fieldname
  codigo.DataField := 'codigo';
  nome.DataField := 'nome';

  ColocaMascaraCampos;
  //coloca o focus em um objeto
  CampoPesquisa.ItemIndex := 0 ;
  CampoPesquisa.SetFocus;

end;

procedure TFrmCadastroCliente.ColocaMascaraCampos();
var
  j : integer;
begin
   for j:=0 to sqlmanipula.Fields.Count-1 do begin
     if (sqlmanipula.Fields.Fields[j].DataType = ftDate) then
      sqlmanipula.Fields.Fields[j].EditMask := '99/99/9999;1; ';
     if (sqlmanipula.Fields.Fields[j].FullName = 'cep')then
      sqlmanipula.Fields.Fields[j].EditMask := '99999-999;1; ';
     if (sqlmanipula.Fields.Fields[j].FullName = 'cgc')then
      sqlmanipula.Fields.Fields[j].EditMask := '99.999.999.9999-99;1; ';
     if (sqlmanipula.Fields.Fields[j].FullName = 'telefone') or (sqlmanipula.Fields.Fields[j].FullName = 'fax') or (sqlmanipula.Fields.Fields[j].FullName = 'celular') then
      sqlmanipula.Fields.Fields[j].EditMask := '(99) 9999-9999;1; ';
     if (sqlmanipula.Fields.Fields[j].FullName = 'rg')then
      sqlmanipula.Fields.Fields[j].EditMask := '99.999.999-9;1; ';
     if (sqlmanipula.Fields.Fields[j].FullName = 'cic')then
      sqlmanipula.Fields.Fields[j].EditMask := '999.999.9999-9;1; ';
   end;
end;

procedure TFrmCadastroCliente.DBGridTitleClick(Column: TColumn);
begin
  Ordenar_Select(Column.FieldName);
end;

procedure TFrmCadastroCliente.pesquisarClick(Sender: TObject);
var
  aRetorno : string;
begin
  if not validadados(chavepesquisa.Text) then begin
    application.MessageBox('Dados Para Pesquisa No So Vlidos !','Aviso',mb_iconexclamation);
    chavepesquisa.SetFocus;
    exit;
  end else if trim(chavepesquisa.Text) = '' then begin
    application.MessageBox('Preencha O Que Vai Ser Pesquisado !','Aviso',mb_iconexclamation);
    chavepesquisa.SetFocus;
    exit;
  end;

  aRetorno := RetornaTipoCampo(colocaunderline(primeiraletraminuscula(CampoPesquisa.Text)));
  SQLManipula.Close;
  SQLManipula.SQL.Clear;
  if aRetorno = 'INTEIRO' then begin
    SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + colocaunderline(primeiraletraminuscula(campopesquisa.Text)) + ' = :nValor ');
    SQLManipula.ParamByName('nValor').AsInteger := strToInt(TiraPonto(ChavePesquisa.text)) ;
  end else if aRetorno = 'NUMERO' then begin
    SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + colocaunderline(primeiraletraminuscula(campopesquisa.Text)) + ' = :nValor ');
    SQLManipula.ParamByName('nValor').AsString := trim(ChavePesquisa.text);
  end else if aRetorno = 'TEXTO' then begin
    SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + colocaunderline(primeiraletraminuscula(campopesquisa.Text)) + ' like :nValor ');
    SQLManipula.ParamByName('nValor').AsString := ChavePesquisa.text + '%' ;
  end else if aRetorno = 'DATA' then begin
    SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + colocaunderline(primeiraletraminuscula(campopesquisa.Text)) + ' = :nValor ');
    SQLManipula.ParamByName('nValor').AsDate := strToDate(ChavePesquisa.text);
  end else begin
    SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + CampoReferencial + ' IS NULL');
  end;
  SQLManipula.Open;
  ColocaMascaraCampos();
  ChavePesquisa.SetFocus;
  ChavePesquisa.SelectAll;
end;

procedure TFrmCadastroCliente.DBGridDblClick(Sender: TObject);
begin
  Pagecontrol.TabIndex := 1 ;
end;

procedure TFrmCadastroCliente.incluirClick(Sender: TObject);
begin
  SQLManipula.Append;
  HabilitaBotoes(2);
end;

procedure TFrmCadastroCliente.alterarClick(Sender: TObject);
begin
  if not sqlManipula.FieldByName(camporeferencial).IsNull then begin
    sqlmanipula.Edit;
    nFlagAlterar := true;    
  end else begin
    alerta('Nenhum Registro Selecionado Para Alterao !');
    exit ;
  end;
  HabilitaBotoes(2);
end;

procedure TFrmCadastroCliente.excluirClick(Sender: TObject);
begin
  if not sqlManipula.FieldByName(camporeferencial).IsNull then
    sqlmanipula.delete
  else begin
    alerta('Nenhum Registro Selecionado Para Excluso !');
    exit ;
  end;
  SQLmanipula.Refresh;
end;

procedure TFrmCadastroCliente.salvarClick(Sender: TObject);
var
 nCodigo : integer;
 ultimoCodigo : TZquery ;
begin
  if not nFlagAlterar then begin
    //Pega o Ultimo Codigo da tabela
    ultimoCodigo := TZquery.Create(nil);
    ultimoCodigo.Connection := BancoDados.Conexao;
    ultimoCodigo.SQL.Clear;
    ultimoCodigo.SQL.Add('select max('+trim(campoReferencial)+') as codigo from '+Tabelareferencial);
    ultimoCodigo.Open;
    ultimoCodigo.first;
    nCodigo := ultimoCodigo.FieldByName('codigo').AsInteger + 1;
    codigo.Text := IntToStr(nCodigo);
    ultimoCodigo.Close;
    ultimoCodigo.Free;
  end;
  sqlmanipula.Post;
  nFlagAlterar := false;
  HabilitaBotoes(1);
end;

procedure TFrmCadastroCliente.abandonarClick(Sender: TObject);
begin
  SQLManipula.Cancel;
  SQLManipula.CancelUpdates;
  HabilitaBotoes(1);
  nFlagAlterar := false;  
end;

procedure TFrmCadastroCliente.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TFrmCadastroCliente.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = #13) then begin
    Key := #0;
    SelectNext(activeControl,true,true);
  end;
end;

procedure TFrmCadastroCliente.HabilitaBotoes(aOpcao:integer);
begin
  ColocaMascaraCampos();
  incluir.Enabled := not(incluir.Enabled);
  alterar.Enabled := not(alterar.Enabled);
  excluir.Enabled := not(excluir.Enabled);
  salvar.Enabled := not(salvar.Enabled);
  abandonar.Enabled := not(abandonar.Enabled);
end;

procedure TFrmCadastroCliente.Ordenar_Select(OS_Campo: String);
var
  Temp1: Boolean;
  Temp3: Integer;
begin
  Temp1:=True;
  for Temp3:=0 to SQLManipula.SQL.Count-1 do if Pos('order',LowerCase(SQLManipula.SQL.Strings[Temp3]))>0 then begin
    Temp1:=False;
    SQLManipula.SQL.Strings[Temp3]:='order by '+OS_Campo;
  end;
  if Temp1 then SQLManipula.SQL.Add('order by '+OS_Campo);
  SQLManipula.Close;
  SQLManipula.open;
end;

procedure TFrmCadastroCliente.PageControlChanging(Sender: TObject; var AllowChange: Boolean);
begin
  AllowChange := incluir.Enabled;
end;

procedure TFrmCadastroCliente.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //se for pressionado ESC
  if (key = vk_escape ) then begin
    //fecha o Form
    close;
  end;
end;

procedure TFrmCadastroCliente.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if salvar.Enabled then begin
    alerta('No Foi Possvel Executar A Operao Pois Existe'+chr(13)+chr(10)+'Uma Incluso Ou Alterao Est Em Andamento !');
    canclose := false;
  end;
end;

function TFrmCadastroCliente.ValidaDados(aValor: String):boolean;
var
  aRetorno : String;
  i : integer;
begin
  aRetorno := RetornaTipoCampo(colocaunderline(primeiraletraminuscula(CampoPesquisa.Text)));
  for i :=1 to length(trim(Avalor)) do begin
    if aRetorno = 'NUMERO' then begin // caso o tipo do campo seja um numero
      if not(aValor[i] in['0'..'9',#8,'.']) then begin
        result := false;
        exit;
      end;
    end else if aRetorno = 'INTEIRO' then begin // caso o tipo do campo seja um numero INTEIRO
      if not(aValor[i] in['0'..'9',#8]) then begin
        result := false;
        exit;
      end;
    end else if aRetorno = 'DATA' then begin // caso o tipo do campo seja um numero
      if not (ValidarData(aValor)) then begin
        result := false;
        exit;
      end;
    end;
  end;
  result := true;
end;

function TFrmCadastroCliente.RetornaTipoCampo(NomeCampo : String): String;
var
  aux : TFieldType;
begin
  aux := SQLManipula.FieldDefs.Items[SQLManipula.FieldDefs.IndexOf(NomeCampo)].DataType;
  if (aux=ftFloat) or (aux=ftCurrency) or (aux=ftFMTBcd) then
    RetornaTipoCampo := 'NUMERO'
  else if (aux=ftSmallint) or (aux=ftInteger) or (aux=ftWord) or (aux=ftAutoInc) or (aux=ftLargeint) then
    RetornaTipoCampo := 'INTEIRO'
  else if (aux=ftString) or (aux=ftFixedChar) or (aux=ftWideString) then
    RetornaTipoCampo := 'TEXTO'
  else if (aux=ftDate) or (aux=ftTime) or (aux=ftDateTime) or (aux=ftTimeStamp) then
    RetornaTipoCampo := 'DATA'
  else
    RetornaTipoCampo := 'DESCONHECIDO';
end;

procedure TFrmCadastroCliente.FormDestroy(Sender: TObject);
begin
  FrmCadastroCliente := nil;
end;

end.
