unit UfrmPesquisaSimples;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, StdCtrls, Buttons, Grids, DBGrids, ExtCtrls,
  DB, SqlExpr, Provider, DBClient, uBancoDados, Funcoes, ZAbstractRODataset,
  ZAbstractDataset, ZDataset;

type
  TfrmPesquisaSimples = class(TForm)
    DataSource: TDataSource;
    Panel1: TPanel;
    Panel2: TPanel;
    DBGrid: TDBGrid;
    Panel3: TPanel;
    ChavePesquisa: TEdit;
    Label1: TLabel;
    Tabela: TZQuery;
    confirmar: TBitBtn;
    cancelar: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure confirmarClick(Sender: TObject);
    procedure cancelarClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ChavePesquisaChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    TabelaReferencial : String;
    CampoReferencial : String;
    Confirma : Boolean;
    strCampos : String;
  end;

var
  frmPesquisaSimples: TfrmPesquisaSimples;

implementation
{$R *.dfm}

procedure TfrmPesquisaSimples.FormShow(Sender: TObject);
var
  i : integer;
begin

  Tabela.SQL.Clear;
  if trim(strCampos) = '' then
   begin
    Tabela.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + CampoReferencial + ' IS NULL ORDER BY ' + CampoReferencial );
   end else begin
    Tabela.SQL.Add('SELECT '+strCampos+' FROM ' + TabelaReferencial + ' WHERE ' + CampoReferencial + ' IS NULL ORDER BY ' + CampoReferencial );
   end;

  Tabela.Open;

  for i := 0 to 1 do begin
    //adiciona nome dos campos da tabela no Grid e trata o nome das colunas
    DBGrid.Columns.Add;
    DBGrid.Columns[i].FieldName := Tabela.FieldDefs.Items[i].Name;
    DBGrid.Columns[i].Title.Caption := PrimeiraLetraMaiscula(TiraUnderline(Tabela.FieldDefs.Items[i].Name));
    DBGrid.Columns[i].Title.Font.Style := [ fsBold ];
  end;

  Confirma := false;
  ChavePesquisa.SetFocus;
end;

procedure TfrmPesquisaSimples.confirmarClick(Sender: TObject);
begin
  Confirma := true;
  Close;
end;

procedure TfrmPesquisaSimples.cancelarClick(Sender: TObject);
begin
  Confirma := false;
  Close;
end;

procedure TfrmPesquisaSimples.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = #13) then begin
    Key := #0;
    SelectNext(activeControl,true,true);
  end;
end;

procedure TfrmPesquisaSimples.ChavePesquisaChange(Sender: TObject);
begin
  tabela.Close;
  tabela.SQL.Clear;
  tabela.SQL.add('select * from ' + TabelaReferencial + ' where ' + CampoReferencial + ' like :aRafael order by ' + CampoReferencial);
  tabela.ParamByName('aRafael').AsString:= Trim(ChavePesquisa.text) + '%';
  tabela.Open;
end;

procedure TfrmPesquisaSimples.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //se for pressionado ESC
  if (key = vk_escape ) then begin
    Confirma := true;
    Close;
  //se a chave de pesquisa estiver com foco
  end else if ChavePesquisa.Focused then begin
    //se pressionar o botao para cima move nos registros encontrados
    if key = vk_up then begin
      if not Tabela.Bof then begin
        Tabela.Prior;
        if Tabela.Bof then begin
          Tabela.First;
        end;
      end;
      //iguinora a tecla pressinada
      key := VK_SHIFT;
    //se pressionar o botao para baixo move nos registros encontrados
    end else if key = vk_down then begin
      if not Tabela.Eof then begin
        Tabela.Next;
        if Tabela.Eof then begin
          Tabela.Last;
        end;
      end;
      //iguinora a tecla pressinada
      key := VK_SHIFT;
    end;
  end;
end;

end.
